<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: I2C Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-attribs">Static Public Attributes</a> &#124;
<a href="classI2C-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">I2C Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Interface to I2C functions.  
 <a href="classI2C.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="I2C_8h_source.html">I2C.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a7a9a84fccdacb3346ff97d6f3e158850"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classI2C.html#a7a9a84fccdacb3346ff97d6f3e158850">I2C</a> ()</td></tr>
<tr class="memdesc:a7a9a84fccdacb3346ff97d6f3e158850"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create an instance of an I2C object.  <a href="#a7a9a84fccdacb3346ff97d6f3e158850">More...</a><br /></td></tr>
<tr class="separator:a7a9a84fccdacb3346ff97d6f3e158850"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a414fa12d9ddd715be6802cd6fbe8d0ed"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classI2C.html#a414fa12d9ddd715be6802cd6fbe8d0ed">beginTransaction</a> ()</td></tr>
<tr class="memdesc:a414fa12d9ddd715be6802cd6fbe8d0ed"><td class="mdescLeft">&#160;</td><td class="mdescRight">Begin a new I2C transaction.  <a href="#a414fa12d9ddd715be6802cd6fbe8d0ed">More...</a><br /></td></tr>
<tr class="separator:a414fa12d9ddd715be6802cd6fbe8d0ed"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad43e562aaf70eac7acca8fde9f904234"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classI2C.html#ad43e562aaf70eac7acca8fde9f904234">endTransaction</a> ()</td></tr>
<tr class="memdesc:ad43e562aaf70eac7acca8fde9f904234"><td class="mdescLeft">&#160;</td><td class="mdescRight">End an <a class="el" href="classI2C.html" title="Interface to I2C functions.">I2C</a> transaction.  <a href="#ad43e562aaf70eac7acca8fde9f904234">More...</a><br /></td></tr>
<tr class="separator:ad43e562aaf70eac7acca8fde9f904234"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa0b398b4369cf4db773aeb579c3919bc"><td class="memItemLeft" align="right" valign="top">uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classI2C.html#aa0b398b4369cf4db773aeb579c3919bc">getAddress</a> () const</td></tr>
<tr class="memdesc:aa0b398b4369cf4db773aeb579c3919bc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the address of the I2C slave against which we are working.  <a href="#aa0b398b4369cf4db773aeb579c3919bc">More...</a><br /></td></tr>
<tr class="separator:aa0b398b4369cf4db773aeb579c3919bc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1d9a7d1373a31adf3c281598ea2c9e18"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classI2C.html#a1d9a7d1373a31adf3c281598ea2c9e18">init</a> (uint8_t address, gpio_num_t sdaPin=<a class="el" href="classI2C.html#a4d371d14b0fcae3b20f22ee8254536b8">DEFAULT_SDA_PIN</a>, gpio_num_t sclPin=<a class="el" href="classI2C.html#aece11572688a31925150176f2241e956">DEFAULT_CLK_PIN</a>, uint32_t clkSpeed=<a class="el" href="classI2C.html#a3343eadb26bb775ed15e7b57ae9abd88">DEFAULT_CLK_SPEED</a>, i2c_port_t portNum=I2C_NUM_0, bool pullup=true)</td></tr>
<tr class="memdesc:a1d9a7d1373a31adf3c281598ea2c9e18"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize the <a class="el" href="classI2C.html" title="Interface to I2C functions.">I2C</a> interface.  <a href="#a1d9a7d1373a31adf3c281598ea2c9e18">More...</a><br /></td></tr>
<tr class="separator:a1d9a7d1373a31adf3c281598ea2c9e18"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac81d33d8192945eb2caa210ae5055851"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classI2C.html#ac81d33d8192945eb2caa210ae5055851">read</a> (uint8_t *bytes, size_t length, bool ack=true)</td></tr>
<tr class="memdesc:ac81d33d8192945eb2caa210ae5055851"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read a sequence of bytes from the slave.  <a href="#ac81d33d8192945eb2caa210ae5055851">More...</a><br /></td></tr>
<tr class="separator:ac81d33d8192945eb2caa210ae5055851"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a732035bfdeb90745e21e3c0cc6a6992c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classI2C.html#a732035bfdeb90745e21e3c0cc6a6992c">read</a> (uint8_t *byte, bool ack=true)</td></tr>
<tr class="memdesc:a732035bfdeb90745e21e3c0cc6a6992c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read a single byte from the slave.  <a href="#a732035bfdeb90745e21e3c0cc6a6992c">More...</a><br /></td></tr>
<tr class="separator:a732035bfdeb90745e21e3c0cc6a6992c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad3ebfa3204880e4fa60beeba997f357a"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classI2C.html#ad3ebfa3204880e4fa60beeba997f357a">scan</a> ()</td></tr>
<tr class="memdesc:ad3ebfa3204880e4fa60beeba997f357a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Scan the <a class="el" href="classI2C.html" title="Interface to I2C functions.">I2C</a> bus looking for devices.  <a href="#ad3ebfa3204880e4fa60beeba997f357a">More...</a><br /></td></tr>
<tr class="separator:ad3ebfa3204880e4fa60beeba997f357a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab6ea7b33432cfea858484411741b3bca"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classI2C.html#ab6ea7b33432cfea858484411741b3bca">setAddress</a> (uint8_t address)</td></tr>
<tr class="memdesc:ab6ea7b33432cfea858484411741b3bca"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the address of the I2C slave against which we will be working.  <a href="#ab6ea7b33432cfea858484411741b3bca">More...</a><br /></td></tr>
<tr class="separator:ab6ea7b33432cfea858484411741b3bca"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a846d50b0bd6b866498f91bfc50b565cc"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classI2C.html#a846d50b0bd6b866498f91bfc50b565cc">setDebug</a> (bool enabled)</td></tr>
<tr class="memdesc:a846d50b0bd6b866498f91bfc50b565cc"><td class="mdescLeft">&#160;</td><td class="mdescRight">enable or disable debugging.  <a href="#a846d50b0bd6b866498f91bfc50b565cc">More...</a><br /></td></tr>
<tr class="separator:a846d50b0bd6b866498f91bfc50b565cc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4acd5dd262eb4638e81f471a5e605194"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classI2C.html#a4acd5dd262eb4638e81f471a5e605194">slavePresent</a> (uint8_t address)</td></tr>
<tr class="memdesc:a4acd5dd262eb4638e81f471a5e605194"><td class="mdescLeft">&#160;</td><td class="mdescRight">Determine if the slave is present and responding.  <a href="#a4acd5dd262eb4638e81f471a5e605194">More...</a><br /></td></tr>
<tr class="separator:a4acd5dd262eb4638e81f471a5e605194"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a07463a2babdabbd675a2745fb53650ca"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classI2C.html#a07463a2babdabbd675a2745fb53650ca">start</a> ()</td></tr>
<tr class="memdesc:a07463a2babdabbd675a2745fb53650ca"><td class="mdescLeft">&#160;</td><td class="mdescRight">Add an I2C start request to the command stream.  <a href="#a07463a2babdabbd675a2745fb53650ca">More...</a><br /></td></tr>
<tr class="separator:a07463a2babdabbd675a2745fb53650ca"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac9a9e5ea511ff86f474866052a7fabf1"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classI2C.html#ac9a9e5ea511ff86f474866052a7fabf1">stop</a> ()</td></tr>
<tr class="memdesc:ac9a9e5ea511ff86f474866052a7fabf1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Add an I2C stop request to the command stream.  <a href="#ac9a9e5ea511ff86f474866052a7fabf1">More...</a><br /></td></tr>
<tr class="separator:ac9a9e5ea511ff86f474866052a7fabf1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4a8d11dbd76409914f1e6404dacb2073"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classI2C.html#a4a8d11dbd76409914f1e6404dacb2073">write</a> (uint8_t byte, bool ack=true)</td></tr>
<tr class="memdesc:a4a8d11dbd76409914f1e6404dacb2073"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write a single byte to the I2C slave.  <a href="#a4a8d11dbd76409914f1e6404dacb2073">More...</a><br /></td></tr>
<tr class="separator:a4a8d11dbd76409914f1e6404dacb2073"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a870ba63321e9a51f4b7475e85ae112ce"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classI2C.html#a870ba63321e9a51f4b7475e85ae112ce">write</a> (uint8_t *bytes, size_t length, bool ack=true)</td></tr>
<tr class="memdesc:a870ba63321e9a51f4b7475e85ae112ce"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write a sequence of byte to the I2C slave.  <a href="#a870ba63321e9a51f4b7475e85ae112ce">More...</a><br /></td></tr>
<tr class="separator:a870ba63321e9a51f4b7475e85ae112ce"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-attribs"></a>
Static Public Attributes</h2></td></tr>
<tr class="memitem:a4d371d14b0fcae3b20f22ee8254536b8"><td class="memItemLeft" align="right" valign="top"><a id="a4d371d14b0fcae3b20f22ee8254536b8"></a>
static const gpio_num_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classI2C.html#a4d371d14b0fcae3b20f22ee8254536b8">DEFAULT_SDA_PIN</a> = GPIO_NUM_25</td></tr>
<tr class="memdesc:a4d371d14b0fcae3b20f22ee8254536b8"><td class="mdescLeft">&#160;</td><td class="mdescRight">The default SDA pin. <br /></td></tr>
<tr class="separator:a4d371d14b0fcae3b20f22ee8254536b8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aece11572688a31925150176f2241e956"><td class="memItemLeft" align="right" valign="top"><a id="aece11572688a31925150176f2241e956"></a>
static const gpio_num_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classI2C.html#aece11572688a31925150176f2241e956">DEFAULT_CLK_PIN</a> = GPIO_NUM_26</td></tr>
<tr class="memdesc:aece11572688a31925150176f2241e956"><td class="mdescLeft">&#160;</td><td class="mdescRight">The default Clock pin. <br /></td></tr>
<tr class="separator:aece11572688a31925150176f2241e956"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3343eadb26bb775ed15e7b57ae9abd88"><td class="memItemLeft" align="right" valign="top"><a id="a3343eadb26bb775ed15e7b57ae9abd88"></a>
static const uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classI2C.html#a3343eadb26bb775ed15e7b57ae9abd88">DEFAULT_CLK_SPEED</a> = 100000</td></tr>
<tr class="memdesc:a3343eadb26bb775ed15e7b57ae9abd88"><td class="mdescLeft">&#160;</td><td class="mdescRight">The default Clock speed. <br /></td></tr>
<tr class="separator:a3343eadb26bb775ed15e7b57ae9abd88"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Interface to I2C functions. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a7a9a84fccdacb3346ff97d6f3e158850"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7a9a84fccdacb3346ff97d6f3e158850">&#9670;&nbsp;</a></span>I2C()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">I2C::I2C </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Create an instance of an I2C object. </p>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a414fa12d9ddd715be6802cd6fbe8d0ed"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a414fa12d9ddd715be6802cd6fbe8d0ed">&#9670;&nbsp;</a></span>beginTransaction()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void I2C::beginTransaction </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Begin a new I2C transaction. </p>
<p>Begin a transaction by adding an I2C start to the queue. </p><dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="ad43e562aaf70eac7acca8fde9f904234"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad43e562aaf70eac7acca8fde9f904234">&#9670;&nbsp;</a></span>endTransaction()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void I2C::endTransaction </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>End an <a class="el" href="classI2C.html" title="Interface to I2C functions.">I2C</a> transaction. </p>
<p>This call will execute the I2C requests that have been queued up since the preceding call to the <a class="el" href="classI2C.html#a414fa12d9ddd715be6802cd6fbe8d0ed" title="Begin a new I2C transaction.">beginTransaction()</a> function. An I2C <a class="el" href="classI2C.html#ac9a9e5ea511ff86f474866052a7fabf1" title="Add an I2C stop request to the command stream.">stop()</a> is also called. </p><dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="aa0b398b4369cf4db773aeb579c3919bc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa0b398b4369cf4db773aeb579c3919bc">&#9670;&nbsp;</a></span>getAddress()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint8_t I2C::getAddress </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the address of the I2C slave against which we are working. </p>
<dl class="section return"><dt>Returns</dt><dd>The address of the I2C slave. </dd></dl>

</div>
</div>
<a id="a1d9a7d1373a31adf3c281598ea2c9e18"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1d9a7d1373a31adf3c281598ea2c9e18">&#9670;&nbsp;</a></span>init()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void I2C::init </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>address</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">gpio_num_t&#160;</td>
          <td class="paramname"><em>sdaPin</em> = <code><a class="el" href="classI2C.html#a4d371d14b0fcae3b20f22ee8254536b8">DEFAULT_SDA_PIN</a></code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">gpio_num_t&#160;</td>
          <td class="paramname"><em>sclPin</em> = <code><a class="el" href="classI2C.html#aece11572688a31925150176f2241e956">DEFAULT_CLK_PIN</a></code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>clockSpeed</em> = <code><a class="el" href="classI2C.html#a3343eadb26bb775ed15e7b57ae9abd88">DEFAULT_CLK_SPEED</a></code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">i2c_port_t&#160;</td>
          <td class="paramname"><em>portNum</em> = <code>I2C_NUM_0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>pullup</em> = <code>true</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Initialize the <a class="el" href="classI2C.html" title="Interface to I2C functions.">I2C</a> interface. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">address</td><td>The address of the slave device. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">sdaPin</td><td>The pin to use for SDA data. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">sclPin</td><td>The pin to use for SCL clock. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="ac81d33d8192945eb2caa210ae5055851"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac81d33d8192945eb2caa210ae5055851">&#9670;&nbsp;</a></span>read() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void I2C::read </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>bytes</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>length</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>ack</em> = <code>true</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Read a sequence of bytes from the slave. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[out]</td><td class="paramname">bytes</td><td>The address into which the read bytes will be stored. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">length</td><td>The number of expected bytes to read. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">ack</td><td>Whether or not we should send an ACK to the slave after reading a byte. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a732035bfdeb90745e21e3c0cc6a6992c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a732035bfdeb90745e21e3c0cc6a6992c">&#9670;&nbsp;</a></span>read() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void I2C::read </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>byte</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>ack</em> = <code>true</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Read a single byte from the slave. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[out]</td><td class="paramname">byte</td><td>The address into which the read byte will be stored. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">ack</td><td>Whether or not we should send an ACK to the slave after reading a byte. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="ad3ebfa3204880e4fa60beeba997f357a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad3ebfa3204880e4fa60beeba997f357a">&#9670;&nbsp;</a></span>scan()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void I2C::scan </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Scan the <a class="el" href="classI2C.html" title="Interface to I2C functions.">I2C</a> bus looking for devices. </p>
<p>A scan is performed on the <a class="el" href="classI2C.html" title="Interface to I2C functions.">I2C</a> bus looking for devices. A table is written to the serial output describing what devices (if any) were found. </p><dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="ab6ea7b33432cfea858484411741b3bca"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab6ea7b33432cfea858484411741b3bca">&#9670;&nbsp;</a></span>setAddress()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void I2C::setAddress </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>address</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the address of the I2C slave against which we will be working. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">address</td><td>The address of the I2C slave. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a846d50b0bd6b866498f91bfc50b565cc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a846d50b0bd6b866498f91bfc50b565cc">&#9670;&nbsp;</a></span>setDebug()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void I2C::setDebug </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>enabled</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>enable or disable debugging. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">enabled</td><td>Should debugging be enabled or disabled. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a4acd5dd262eb4638e81f471a5e605194"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4acd5dd262eb4638e81f471a5e605194">&#9670;&nbsp;</a></span>slavePresent()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool I2C::slavePresent </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>address</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Determine if the slave is present and responding. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">The</td><td>address of the slave. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>True if the slave is present and false otherwise. </dd></dl>

</div>
</div>
<a id="a07463a2babdabbd675a2745fb53650ca"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a07463a2babdabbd675a2745fb53650ca">&#9670;&nbsp;</a></span>start()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void I2C::start </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Add an I2C start request to the command stream. </p>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="ac9a9e5ea511ff86f474866052a7fabf1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac9a9e5ea511ff86f474866052a7fabf1">&#9670;&nbsp;</a></span>stop()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void I2C::stop </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Add an I2C stop request to the command stream. </p>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a4a8d11dbd76409914f1e6404dacb2073"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4a8d11dbd76409914f1e6404dacb2073">&#9670;&nbsp;</a></span>write() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void I2C::write </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>byte</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>ack</em> = <code>true</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Write a single byte to the I2C slave. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">byte</td><td>The byte to write to the slave. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">ack</td><td>Whether or not an acknowledgment is expected from the slave. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a870ba63321e9a51f4b7475e85ae112ce"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a870ba63321e9a51f4b7475e85ae112ce">&#9670;&nbsp;</a></span>write() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void I2C::write </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>bytes</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>length</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>ack</em> = <code>true</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Write a sequence of byte to the I2C slave. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">bytes</td><td>The sequence of bytes to write to the I2C slave. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">length</td><td>The number of bytes to write. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">ack</td><td>Whether or not an acknowledgment is expected from the slave. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="I2C_8h_source.html">I2C.h</a></li>
<li>I2C.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
